; Stepper Motor Driver (normal drive)
; T. Nakagawa
; 2004-10-02,16,2009-03-07

; PB0: X
; PB1: Y
; PB2: ^X
; PB3: ^Y
; PB4: X clk
; PB5: X dir
; PD0: X
; PD1: Y
; PD2: ^X
; PD3: ^Y
; PD4: Y clk
; PD5: Y dir

.include "1200def.inc"

.equ	PATTERN= 0x33	; bit pattern for normal drive

.def	pat0=r16
.def	pat1=r17
.def	stat0=r18
.def	stat1=r19
.def	mask=r20

.cseg
.org 0
	rjmp	init
	reti
	rjmp	ovf
	reti

init:
	ldi	pat0, PATTERN
	ldi	pat1, PATTERN
	ldi	stat0, 0x00
	ldi	stat1, 0x00
	ldi	mask, 0xff
	ldi	ZL, 0x0f
	out	DDRB, ZL
	out	DDRD, ZL
	ldi	ZL, 0xf0
	out	PORTB, ZL
	out	PORTD, ZL
	; timer
	ldi	ZL, 0x05
	out	TCCR0, ZL
	ldi	ZL, 0x02
	out	TIMSK, ZL
	sei
main:
drive0:	; drive the stepper #0
	mov	ZL, pat0
	andi	ZL, 0x0f
	and	ZL, mask
	ori	ZL, 0xf0
	out	PORTB, ZL
drive1:	; drive the stepper #1
	mov	ZL, pat1
	andi	ZL, 0x0f
	and	ZL, mask
	ori	ZL, 0xf0
	out	PORTD, ZL
proc0:	; process the stepper #0
	in	ZL, PINB
	com	stat0
	and	stat0, ZL
	andi	stat0, 0x10
	mov	stat0, ZL
	breq	proc1
	sbis	PINB, 5		; rotate left(CW) or right(CCW)
	lsl	pat0
	sbic	PINB, 5
	lsr	pat0
	bst	pat0, 4
	bld	pat0, 0
	bst	pat0, 3
	bld	pat0, 7
	ldi	ZL, 0x00
	out	TCNT0, ZL
	ser	mask
proc1:	; process the stepper #1
	in	ZL, PIND
	com	stat1
	and	stat1, ZL
	andi	stat1, 0x10
	mov	stat1, ZL
	breq	end
	sbis	PIND, 5		; rotate left(CW) or right(CCW)
	lsl	pat1
	sbic	PIND, 5
	lsr	pat1
	bst	pat1, 4
	bld	pat1, 0
	bst	pat1, 3
	bld	pat1, 7
	ldi	ZL, 0x00
	out	TCNT0, ZL
	ser	mask
end:
	rjmp	main

ovf:
	in	YL, SREG
	com	mask
	ldi	YH, 255	; 1000/1024/2kHz, 1/2 duty
	out	TCNT0, YH
	out	SREG, YL
	reti
